var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var wrapperWithSchema_exports = {};
__export(wrapperWithSchema_exports, {
  wrapFunctionWithSchema: () => wrapFunctionWithSchema
});
module.exports = __toCommonJS(wrapperWithSchema_exports);
var import_jsonschema = require("jsonschema");
var import_wrapper = require("./wrapper.js");
var import_error = __toESM(require("@fastify/error"), 1);
const ValidationError = (0, import_error.default)("VALIDATION_ERROR", "Input is invalid on property path %s", 400);
const wrapFunctionWithSchema = (logic, schema) => async (args) => {
  async function wrappedValidationLogic(innerArgs) {
    const valid = (0, import_jsonschema.validate)(innerArgs, schema);
    if (!innerArgs) {
      throw new ValidationError("$ (root)");
    } else if (valid.valid) {
      return await logic(innerArgs);
    } else {
      throw new ValidationError(valid.propertyPath);
    }
  }
  return await (0, import_wrapper.wrapFunction)(wrappedValidationLogic)(args);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  wrapFunctionWithSchema
});
