var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var wrapper_exports = {};
__export(wrapper_exports, {
  wrapFunction: () => wrapFunction
});
module.exports = __toCommonJS(wrapper_exports);
const wrapFunction = (logic) => async (args) => {
  let response;
  try {
    const result = await logic(args);
    response = { headers: { "content-type": "application/json" }, body: JSON.stringify(result), statusCode: 200 };
  } catch (e) {
    if (e.name === "FastifyError") {
      response = {
        headers: { "content-type": "application/json" },
        body: JSON.stringify({ msg: e.message, code: e.code }),
        statusCode: e.statusCode
      };
    } else {
      response = {
        headers: { "content-type": "application/json" },
        body: JSON.stringify({ msg: e.message }),
        statusCode: 500
      };
    }
  }
  return response;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  wrapFunction
});
