import { stat } from "fs/promises";
async function fileExists(filename) {
  const s = await stat(filename).catch((e) => null);
  return s?.isFile();
}
async function firstExists(...filePaths) {
  for (const file of filePaths)
    if (await fileExists(file))
      return file;
}
export {
  fileExists,
  firstExists
};
